# -*- coding: utf-8 -*-
"""SARIMA.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1ff-nYGaMLJN8DBhzONN2If36n3WgEn-O
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt

import warnings
import itertools
import statsmodels.api as sm

time_series = pd.read_excel('ARIMA.xlsx')
time_series

time_series['Date'] = pd.to_datetime(time_series['Date'])

time_series.set_index('Date', inplace=True)

time_series.info()

plt.figure(figsize=(15,8))
plt.plot(time_series['Prise'])
plt.title('График временного ряда')
plt.xlabel('Дата')

from statsmodels.tsa.stattools import adfuller

print('Результат теста:')
df_result = adfuller(time_series['Prise'])
df_labels = ['ADF Test Statistic', 'p-value', '#Lags Used', 'Number of Observations Used']
for result_value, label in zip(df_result, df_labels):
    print(label + ' : ' + str(result_value))

if df_result[1] <= 0.05:
    print("Сильные доказательства против нулевой гипотезы, ряд является стационарным.")
else:
    print("Слабые доказательства против нулевой гипотезы, ряд не является стационарным.")

from statsmodels.tsa.arima.model import ARIMA
from statsmodels.tsa.stattools import acf, pacf
from statsmodels.graphics.tsaplots import plot_acf, plot_pacf

warnings.filterwarnings("ignore")

def search_optimal_sarima(time_series, seasonal_cycle):
    order_vals = diff_vals = ma_vals = range(0, 2)
    pdq_combinations = list(itertools.product(order_vals, diff_vals, ma_vals))
    seasonal_combinations = [(combo[0], combo[1], combo[2], seasonal_cycle) for combo in pdq_combinations]

    smallest_aic = float("inf")
    optimal_order_param = optimal_seasonal_param = None

    for order_param in pdq_combinations:
        for seasonal_param in seasonal_combinations:
            try:
                sarima_model = sm.tsa.statespace.SARIMAX(time_series,
                                                         order=order_param,
                                                         seasonal_order=seasonal_param,
                                                         enforce_stationarity=False,
                                                         enforce_invertibility=False)

                model_results = sarima_model.fit()
                if model_results.aic < smallest_aic:
                    smallest_aic = model_results.aic
                    optimal_order_param = order_param
                    optimal_seasonal_param = seasonal_param
            except:
                continue

    print('ARIMA{}x{} - AIC:{}'.format(optimal_order_param, optimal_seasonal_param, smallest_aic))

seasonal_cycle_length = 52
search_optimal_sarima(time_series, seasonal_cycle_length)

from statsmodels.tsa.statespace.sarimax import SARIMAX
model = SARIMAX(time_series, order=(0, 1, 1), seasonal_order=(1, 1, 0, 52))

results = model.fit()

print(results.summary())

results.plot_diagnostics(figsize=(12, 8))
plt.show()

st_pred = results.get_prediction(start=pd.to_datetime('2018-12-31'), dynamic=False)
forecast_values = st_pred.predicted_mean

actual_values = time_series['2018-12-31':]['Prise']
forecast_mse = ((forecast_values - actual_values) ** 2).mean()
print('Среднеквадратичная ошибка прогноза составляет {}'.format(round(forecast_mse, 2)))

plt.figure(figsize=(15,8))

plt.plot(actual_values.index, actual_values, label='Реальные значения', color='blue')

plt.plot(forecast_values.index, forecast_values, label='Спрогнозированные значения', color='red')

plt.title('Реальные и cпрогнозированные значения')
plt.xlabel('Дата')
plt.ylabel('Цена')
plt.legend()

plt.show()

pred_future = results.get_forecast(steps=29)

d = pd.DataFrame(pred_future.predicted_mean)
d.reset_index(drop= True, inplace= True)
df2 = pd.read_excel("Date2.xlsx")
df3 = df2.join(d)

df3.rename(columns={'predicted_mean': 'revenue'}, inplace=True)

df3.head()

df3.to_csv("output.csv", index=False)

print(f'Средние прогнозируемые значения:\n\n{pred_future.predicted_mean}')
print(f'\nДоверительные интервалы:\n\n{pred_future.conf_int()}')

fig = plt.figure()
plt.plot(pred_future.predicted_mean, label='Средние прогнозируемые значения')
plt.fill_between(pred_future.conf_int().index,
                 pred_future.conf_int().iloc[:, 0],
                 pred_future.conf_int().iloc[:, 1], color='k', alpha=.2)
plt.legend()
plt.show()